(setq *default-pathname-defaults* *load-pathname*)



(load "net")
(load "tools")
(load "my-http")
(load "config")

(use-package :tools)
(use-package :my-http)


(defvar *server-port* 8080)
(defvar *server-sock* nil)

(defvar *content* "")
(defvar *log-in* (make-hash-table :test #'equal))
(defvar *log-file* nil)
(defvar *tempfile* "temp.tmp")
(defvar *savedir* "")

;;(defvar *time-green* 10)
;;(defvar *time-yellow* 20)
;;(defvar *time-red* 30)

(defvar *time-green* 60)
(defvar *time-yellow* 120)
(defvar *time-red* 300)

(defvar *last-dice-login* nil)
(defvar *dice1* nil)
(defvar *dice2* nil)



(defun add-to-content (new-content)
  (when new-content
    (setq *content* (format nil "~A~A~%"
			    *content*
			    new-content))
    (when *log-file*
      (with-open-file
       (stream *log-file*
	       :direction :output
	       :if-exists :append
	       :if-does-not-exist :create)
       (format stream "~A~%" new-content)))))



(defun head-title-string (head-title title)
  (format nil "<html>
<head>
  <!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"
     \"http://www.w3.org/TR/html4/transitional.dtd\">
  <title>~A</title>
</head>
<body>
  <a name=\"haut\"></a>

  <h1>~A</h1>~%"
	  head-title title))

(defun login-form-string (host)
  (format nil "<p>
  <form action=\"http://~A\" method=\"post\"
        enctype=\"application/x-www-form-urlencoded\">
    Entrez votre login:
    <input type=\"text\" name=\"login\"/><br>

    <INPUT type=\"submit\" value=\"Rentrer\"/> <INPUT type=\"reset\" value=\"Remise  zro\"/>
  </form>
  </p>~%"
	  host))


(defun main-page-string ()
  (format nil "    <br>
    <br>
    <table width=\"100%\" border=\"1\"
       cols=\"2\" cellspacing=\"0\" cellpadding=\"3\">
    <tr valign=\"top\" align=\"left\">
      <td colspan=\"2\" bgcolor=\"#CDCEEE\">
        <a href=\"#bas\">
          <IMG SRC=\"/down.png\" Border=0 alt=\"down\" width=\"25\" height=\"25\"></a>
        ~A</td>
    </tr>
    <tr valign=\"top\" align=\"left\">
      <td width=\"80%\">~A</td>
      <td bgcolor=\"#CDCEEE\">~A</td>
    </tr>
    <tr valign=\"top\" align=\"left\">
       <td colspan=\"2\" bgcolor=\"#CDCEEE\">
         <a href=\"#haut\">
           <IMG SRC=\"/top.png\" Border=0 alt=\"top\" width=\"25\" height=\"25\"></a>
         ~A</td>
    </tr>
    </table>
    <br>~%"
	  (format-log-in-top)
	  *content*
	  (format-log-in)
	  (format-log-in-top)))



(defun img-dice-string (color dice)
  (if dice
      (format nil "<img src=\"de_~A_~A.png\" Border=0 alt=\"~A ~A\">"
	      color dice color dice)
    ""))

(defun main-form-string (host login)
  (format nil "<p>
<form action=\"http://~A/$~A\" method=\"post\"
        enctype=\"application/x-www-form-urlencoded\">
    <center>
    <textarea name=\"content\" rows=\"3\" cols=\"80\"></textarea><br><br>

    <INPUT type=\"submit\" value=\"Envoyer\"> <INPUT type=\"reset\" value=\"Reset\">
    </center>
</form>
</p>

<p>
<a href=\"http://~A/send_file.html/$~A\">Partager un fichier</a>
</p>
<p>
<a href=\"http://~A/send_dice.html/$~A\">
  Lancer un d 10 &nbsp; <img src=\"de_vert_0.png\" Border=0 alt=\"send_dice\"></a>
&nbsp; &nbsp; &nbsp;
<a href=\"http://~A/send_2_dice.html/$~A\">
  Lancer deux ds 10 &nbsp; <img src=\"de_vert_0.png\" Border=0 alt=\"send_dice\">
  <img src=\"de_mauve_0.png\" Border=0 alt=\"send_dice\"></a>
</p>
<p>
Dernier lanc : <font color=\"red\">~A</font> &nbsp; ~A &nbsp; ~A
</p>~%"
	  host login
	  host login
	  host login
	  host login
	  (or *last-dice-login* "Personne")
	  (img-dice-string "vert" *dice1*)
	  (img-dice-string "mauve" *dice2*)))


(defun ask-post-string (host login)
  (format nil "<p>
 <center>
    <a href=\"http://~A/$~A\">POSTER UN MESSAGE</a>
 </center>
</p>~%"
	  host login))


(defun bottom-title-string ()
  (format nil "  <a name=\"bas\"></a>
</body>
</html>~%"))



	  


(defun send-login-page (sock host)
  (send-http sock "text/html"
	     (concatenate 'string
			  (head-title-string
			   "CLWebChat:Login"
			   "Login sur la console web/lisp (<a href=\"help.html\">Aide</a>)")
			  (login-form-string host)
			  (main-page-string)
			  (bottom-title-string))))
			  






(defun send-basic-page (sock host title string url-return string-return)
  (send-http sock "text/html"
	     (format nil "<html>
<head>
  <!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"
     \"http://www.w3.org/TR/html4/transitional.dtd\">
  <title>~A</title>
</head>
<body>
  ~A<br>
  <a href=\"~A\">~A</a><br><br>
  <small><a href=\"http://~A\">http://~A</a></small>
</body>
</html>" title string url-return string-return host host)))


(defun send-help-page (sock)
  (send-http sock "text/html"
	     (format nil "<html>
<head>
  <!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"
     \"http://www.w3.org/TR/html4/transitional.dtd\">
  <title>CLWebChat:Aide</title>
</head>
<body>
  <h1><u>Aide</u><br></h1>
  <p>
  Entrez un login pour pouvoir dialoguer avec les autres.<br>
  <br>
  <u>Lgende</u><br>
  <img src=\"con-green.png\" width=\"18\" height=\"18\"> &nbsp; moins de ~A minutes se sont
coules depuis le dernier passage de la personne.<br>
  <img src=\"con-yellow.png\" width=\"18\" height=\"18\"> &nbsp;  moins de ~A minutes se sont
coules depuis le dernier passage de la personne.<br>
  <img src=\"con-red.png\" width=\"18\" height=\"18\"> &nbsp;  moins de ~A minutes se sont
coules depuis le dernier passage de la personne.<br>
  <br>
  <u>Balises</u><br>
  Les balises suivantes sont autorises :<br>
  &nbsp; &nbsp; &lt;b&gt;<b>Gras</b>&lt;/b&gt;<br>
  &nbsp; &nbsp; &lt;i&gt;<i>Italique</i>&lt;/i&gt;<br>
  &nbsp; &nbsp; &lt;u&gt;<u>Soulign</u>&lt;/u&gt;<br>
  <br>
  Les adresses <b>http://</b> sont interprtes :<br>
  &nbsp; &nbsp; Tapez <b>http://toto.titi.html</b> pour obtenir
  <a href=\"http://toto.titi.html\">http://toto.titi.html</a><br>
  <br>
  Vous pouvez inserer des images en tapant :
  <b>img://l'url_de_l'image</b><br>
  &nbsp; &nbsp; Par exemple : <b>img://toto.titi.fr/plop.png</b> fera apparaitre l'image
  se trouvant  l'adresse <b>http://toto.titi.fr/plop.png</b><br>
  <br>
  <u>Code source</u><br>
  Pour ceux que a intresse, le code source du serveur est ici :
  <a href=\"http://hocwp.free.fr/clwebchat\">http://hocwp.free.fr/clwebchat</a>,
  il fonctionne aussi bien sous GNU/Linux, *BSD, Windows, MacOS...
  et il est sous <a href=\"http://www.gnu.org\">licence GPL</a>.
  </p>"
		     (/ *time-green* 60)
		     (/ *time-yellow* 60)
		     (/ *time-red* 60))))





(defun string-universal-time (&optional (utime (get-universal-time)))
  (cond ((eql utime :NEW) "New")
	((numberp utime )
	 (multiple-value-bind (s min h d m y)
	     (decode-universal-time utime)
	   (format nil "~2,'0D:~2,'0D:~2,'0D ~2,'0D-~2,'0D-~4,'0D"
		   h min s d m y)))
	(t "New")))

(defun get-time-string (&optional (date (get-universal-time)))
  (multiple-value-bind (s m h)
      (decode-universal-time date)
    (declare (ignore s))
    (format nil "[~2,'0D:~2,'0D]" h m)))


(defun add-log-in (login)
    (setf (gethash login *log-in*) (get-universal-time)))



(defun image-from-date (date)
  (let ((el-time (- (get-universal-time) date)))
    (cond ((< el-time *time-green*) "/con-green.png")
	  ((< el-time *time-yellow*) "/con-yellow.png")
	  ((< el-time *time-red*) "/con-red.png")
	  (t "/con-decon.png"))))
	  

(defun format-log-in ()
  (with-output-to-string
    (str)
    (maphash #'(lambda (key val)
		 (format str "<img src=\"~A\" width=\"18\" height=\"18\"> <b>~A</b> <small>[~A]</small><br>~%"
			 (image-from-date val)
			 key
			 (string-universal-time val)))
	     *log-in*)
    str))

(defun format-log-in-top ()
  (let ((cur-time (get-universal-time)))
    (with-output-to-string
      (str)
      (maphash #'(lambda (key val)
		   (when (< (- cur-time val) *time-red*)
		     (format str "<img src=\"~A\" width=\"18\" height=\"18\">~A~%"
			     (image-from-date val)
			     key)))
	       *log-in*)
      str)))



(defun send-main-page (sock host login)
  (when (string= login "")
    (setq login "Anonyme"))
  (add-log-in login)
  (send-http sock "text/html"
	     (concatenate 'string
			  (head-title-string
			   "CLWebChat:Chat"
			   (format nil "<a href=\"#bas\">
<img src=\"/down.png\" Border=0 alt=\"down\" width=\"25\" height=\"25\"></a>
&nbsp; Bienvenue \"<b><font color=\"red\">~A</font></b>\"
  sur la console <a href=\"http://~A\">web/lisp</a>
  (<a href=\"help.html\">Aide</a>)
&nbsp;
<a href=\"#bas\">
<img src=\"/down.png\" Border=0 alt=\"down\" width=\"25\" height=\"25\"></a>~%"
				   login
				   host))
			  (main-page-string)
			  (main-form-string host login)
			  (bottom-title-string))))


(defun send-post-page (sock host login)
  (when (string= login "")
    (setq login "Anonyme"))
  (add-log-in login)
  (send-http sock "text/html"
	     (concatenate 'string
			  (head-title-string
			   "CLWebChat:Chat"
			   (format nil "Bienvenue \"<b><font color=\"red\">~A</font></b>\"
  sur la console <a href=\"http://~A\">web/lisp</a>
  (<a href=\"help.html\">Aide</a>)~%"
				   login
				   host))
			  (ask-post-string host login)
			  (main-page-string)
			  (ask-post-string host login)
			  (bottom-title-string))))



(defun replace-less-than-tags (content)
  (subst-strings "&gt;" ">"
		 (subst-strings "&lt;" "<" content)))

(defun replace-newlines (content)
  (subst-strings "<br>" (string #\LineFeed)
		 (string-trim '(#\LineFeed) content)))

(defun replace-tags (tag content)
  (subst-strings
   #'(lambda (str pos1 pos2)
       (if pos2
	   (format nil "<~A>~A</~A>" tag (subseq str (+ pos1 9) (- pos2 10)) tag)
	 (subseq str pos1 pos2)))
   (format nil "&lt;~A&gt;" tag) content
   :test #'(lambda (str pos1 pos2)
	     (multiple-value-bind
		 (npos1 npos2)
		 (find-string (format nil "&lt;/~A&gt;" tag) str :start pos2)
	       (declare (ignore npos1))
	       (values pos1 npos2)))))


(defun replace-http-url (content)
  (subst-strings
   #'(lambda (str pos1 pos2)
       (if pos2
	   (let ((sub (subseq str pos1 pos2)))
	     (format nil "<a href=\"~A\">~A</a>" sub sub))
	 (subseq str pos1 pos2)))
   "http://" content
   :test #'(lambda (str pos1 pos2)
   	     (multiple-value-bind (npos1) (find-string "<" str :start pos2)
	       (if npos1
		   (values pos1 npos1)
		 (multiple-value-bind (npos1) (find-string "&lt;" str :start pos2)
		   (if npos1
		       (values pos1 npos1)
		     (multiple-value-bind (npos1) (find-string " " str :start pos2)
		       (if npos1
			   (values pos1 npos1)
			 (values pos1 (length content)))))))))))


(defun replace-http-image (content)
  (subst-strings
   #'(lambda (str pos1 pos2)
       (if pos2
	   (let ((sub (subseq str (+ pos1 6) pos2)))
	     (format nil "<img src=\"http://~A\">" sub))
	 (subseq str pos1 pos2)))
   "img://" content
   :test #'(lambda (str pos1 pos2)
   	     (multiple-value-bind (npos1) (find-string "<" str :start pos2)
	       (if npos1
		   (values pos1 npos1)
		 (multiple-value-bind (npos1) (find-string "&lt;" str :start pos2)
		   (if npos1
		       (values pos1 npos1)
		     (multiple-value-bind (npos1) (find-string " " str :start pos2)
		       (if npos1
			   (values pos1 npos1)
			 (values pos1 (length content)))))))))))


(defun replace-smiley (content)
  (subst-strings
   "<img src=\"happy.png\">" ":)"
   (subst-strings
    "<img src=\"sad.png\">" ":("
    content)))




(defun update-main-page (sock host login content)
  (add-to-content
   (format nil
	   "<font color=\"#007F7F\">~A</font> <font color=\"red\">~A</font>: ~A<br>"
	   (get-time-string) login
	   (replace-smiley
	    (replace-http-image
	     (replace-http-url
	      (replace-tags
	       "i"
	       (replace-tags
		"b"
		(replace-tags
		 "u"
		 (replace-newlines
		  (replace-less-than-tags
		   (clean-http-content content)))))))))))
  (send-post-page sock host login))


(defun send-image (sock image)
  (send-file-http sock (format nil "~A~A" *share-dir* image)))





(defun form-sendfile-string (host login)
  (format nil "<form action=\"http://~A/get_file.html/$~A\"
      method=\"post\"
      enctype=\"multipart/form-data\">
<p>
~A, choisissez un fichier de votre ordinateur  mettre sur le serveur :<br><br>
  <input name=\"fichier\" type=\"file\" size=\"50\" accept=\"*\"><br><br>
  <INPUT type=\"submit\" value=\"Envoyer\"> <INPUT type=\"reset\" value=\"Reset\">
</p>
</form>~%"
	  host login (string-capitalize login)))


(defun send-sendfile-page (sock host login)
  (send-http sock "text/html"
	     (concatenate 'string
			  (head-title-string
			   "CLWebChat:SendFile"
			   "Partager un fichier")
			  (form-sendfile-string host login)
			  (bottom-title-string))))



(defun get-file-from-browser (sock headers)
  (let* ((host (first headers))
	 (filename (fourth headers))
	 (filename-url (concatenate 'string *savedir*
				    (subst-strings "%20" " " filename)))
	 (login (subseq (third headers) 16)))
    (if filename
	(progn
	  (add-to-content (format nil "<font color=\"#007F7F\">~A</font> <font color=\"blue\">~A</font>:
<font color=\"red\">==></font> <a href=\"http://~A/~A\">~A</a> <font color=\"red\"><==</font><br>~%"
				  (get-time-string) login
				  host filename-url filename))
	  (send-basic-page sock host
			   "Fichier reu"
			   "Le fichier que vous avez envoy a t bien reu:<br><br>"
			   (format nil "http://~A/$~A" host login)
			   "Retour  la page de chat"))
      (send-basic-page sock host
			   "Erreur"
			   (format nil
				   "~A, le fichier que vous avez envoy n'a pas t bien reu.<br><br>~%"
				   (string-capitalize login))
			   (format nil "http://~A/$~A" host login)
			   "Retour  la page de chat"))))


(defun find-file-in-share-dir (headers)
  (probe-file (concatenate 'string *share-dir*
			   (clean-http-content (subseq (third headers) 1)))))

(defun send-file-in-share-dir (sock headers)
  (send-file-http sock (concatenate 'string *share-dir*
				    (clean-http-content (subseq (third headers) 1)))))



(defun find-file-in-save-dir (headers)
  (probe-file (concatenate 'string
			   (clean-http-content (subseq (third headers) 1)))))

(defun send-file-in-save-dir (sock headers)
  (send-file-http sock (concatenate 'string
				    (clean-http-content (subseq (third headers) 1)))))



(defun send-one-dice (sock host login)
  (setq *dice1* (random 10))
  (setq *dice2* nil)
  (setq *last-dice-login* login)
  (send-basic-page sock host
		   "Lancer: 1 d 10"
		   (format nil "Lancer: 1 d 10<br><br>
Rsultat : &nbsp; <img src=\"/de_vert_~A.png\" width=\"50\" height=\"32\"><br><br>~%" *dice1*)
		   (format nil "http://~A/$~A" host login)
		   "Retour  la page de chat")
  (add-to-content (format nil "<font color=\"#007F7F\">~A</font> <font color=\"blue\">~A</font>
lance 1 d 10 : &nbsp; <font color=\"#00BB00\">~A</font><br>~%"
			  (get-time-string) login
			  *dice1*)))


(defun send-two-dice (sock host login)
  (setq *dice1* (random 10))
  (setq *dice2* (random 10))
  (setq *last-dice-login* login)
  (send-basic-page sock host
		   "Lancer: 2 ds 10"
		   (format nil "Lancer: 2 ds 10<br><br>
Rsultat : &nbsp; <img src=\"/de_vert_~A.png\" width=\"50\" height=\"32\">
 &nbsp; <img src=\"/de_mauve_~A.png\" width=\"50\" height=\"32\"><br><br>~%"
			   *dice1* *dice2*)
		   (format nil "http://~A/$~A" host login)
		   "Retour  la page de chat")
(add-to-content (format nil "<font color=\"#007F7F\">~A</font> <font color=\"blue\">~A</font>
lance 2 ds 10 : &nbsp; <font color=\"#00BB00\">~A</font> 
<font color=\"#BB00BB\">~A</font><br>~%"
			  (get-time-string) login
			  *dice1* *dice2*)))






(defun send-page (sock headers)
  (let ((host (first headers))
	(type-request (second headers))
	(url (third headers)))
    (case type-request
      (:get (cond ((string= url "/")
		   (send-login-page sock host))
		  ((eql (aref url 1) #\$)
		   (send-main-page sock host
				   (clean-http-content (subseq url 2))))
		  ((string= url "/help.html") (send-help-page sock))
		  ((find-file-in-share-dir headers)
		   (send-file-in-share-dir sock headers))
		  ((and (>= (length url) 15)
			(string= (subseq url 0 15) "/send_file.html"))
		   (send-sendfile-page sock host (subseq url 17)))
		  ((and (>= (length url) 15)
			(string= (subseq url 0 15) "/send_dice.html"))
		   (send-one-dice sock host (subseq url 17)))
		  ((and (>= (length url) 17)
			(string= (subseq url 0 17) "/send_2_dice.html"))
		   (send-two-dice sock host (subseq url 19)))
		  ((find-file-in-save-dir headers)
		   (send-file-in-save-dir sock headers))
		  (t (format t "Adresse inconnue sur GET~%")
		     (send-basic-page sock host
				      "Page introuvable"
				      "Dsol, cette page n'est pas sur le serveur.<br>"
				      (format nil "http://~A" host)
				      "Page principale"))))
      (:post (cond ((string= url "/")
		    (send-post-page sock host
				    (clean-http-content (find-http-headers headers "login"))))
		   ((eql (aref url 1) #\$)
		    (update-main-page sock host
				      (clean-http-content (subseq url 2))
				      (find-http-headers headers "content")))
		   ((and (>= (length url) 14)
			 (string= (subseq url 0 14) "/get_file.html"))
		    (get-file-from-browser sock headers))
		   (t (format t "Adresse inconnue sur POST~%")
		      (send-basic-page sock host
				       "Page introuvable"
				       "Dsol, cette page n'est pas sur le serveur.<br>"
				       (format nil "http://~A" host)
				       "Page principale")))))))



(defun wait-connexion ()
  (let ((sock (net:socket-accept *server-sock*)))
    (unwind-protect
	(ignore-errors
	  (format t "~&******************** New Connexion ********************~%")
	  (let ((headers (get-http sock :tempfile *tempfile* :savedir *savedir*)))
	    (format t "=> Reading headers : ~S~%" headers)
	    (send-page sock headers)))
      (ignore-errors
	(close sock))
      (format t     "~&------------------ End of Connexion ---------------------~%"))))



(defun show-help ()
  (format t "Usage: clwebchat [options]
  Where options are:
    -h, --help            this help
    -p, --port [port]     change server port
    -l, --logfile [file]  file where to put logs
    -s, --savedir [dir]   directory where to save uploaded files~%")
  (quit))



(defun read-command-line ()
  (let ((cmd-line (get-command-line-words)))
    (do ((arg (pop cmd-line) (pop cmd-line)))
	((null arg))
      (case (intern (string-upcase arg))
	((-h --help) (show-help))
	((-p --port) (setf *server-port*
			   (ignore-errors (parse-integer (pop cmd-line)))))
	((-l --logfile) (setf *log-file* (pop cmd-line)))
	((-t --tempfile) (setf *tempfile* (pop cmd-line)))
	((-s --savedir) (setf *savedir* (pop cmd-line)))))))



(read-command-line)

(format t "~&~%Start serveur on port ~A~2%" *server-port*)
(setq *server-sock* (net:open-socket-server *server-port*))

(format t "You can now chat with a web browser pointed to~%")
(format t "http://localhost:~A or for other users http://your-ip:~A~%"
	*server-port* *server-port*)
(format t "(to know your ip, under GNU/linux try /sbin/ifconfig)~%")

(when *log-file*
  (format t "~%Content is logged in ~A~%" *log-file*)
  (with-open-file
   (stream *log-file*
	   :direction :input
	   :if-does-not-exist :create)
   (do ((line (read-line stream nil :eof)
	      (read-line stream nil :eof)))
       ((eql line :eof))
     (setq *content* (concatenate 'string *content* line (string #\linefeed))))))

(unless (string= *savedir* "")
  (setq *savedir* (concatenate 'string *savedir* *separator*))
  (format t "~%Save directory: ~A~%" *savedir*)
  (ensure-directories-exist *savedir* :verbose t))



(catch 'quit
  (unwind-protect
      (loop
       (wait-connexion))
    (net:socket-server-close *server-sock*)
    (format t "~&~%Socket closed.~%")
    (format t "Bye...~%")))

(quit)




